#---
# Excerpted from "Payment Processing with Paypal and Ruby",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/jfpaypal for more book information.
#---

#!/usr/bin/env ruby
require 'soap/header/simplehandler'
require 'defaultDriver'
require 'breakpoint'
require 'pp'


api_user="business_api1.bodkinconsulting.com"
api_pass="wsxwsxwsx"

# This class handles authentication for the soap4r client.

class RequesterCredentialsHandler < SOAP::Header::SimpleHandler
   HeaderName = XSD::QName.new('urn:ebay:api:PayPalAPI', 
       'RequesterCredentials')
   CredentialsName = XSD::QName.new('urn:ebay:apis:eBLBaseComponents', 
       'Credentials')
   UsernameName = XSD::QName.new(nil, 'Username')
   PasswordName = XSD::QName.new(nil, 'Password')
   SubjectName = XSD::QName.new(nil, 'Subject')

   def initialize(username, password, subject)
     super(HeaderName)
     @username, @password, @subject = username, password, subject
   end

   def on_simple_outbound
     {CredentialsName => {UsernameName => @username, PasswordName =>
@password,
       SubjectName => @subject}}
   end
 end 

 
# Either use the endpoint on the command line or the default

endpoint_url = "https://api-aa.sandbox.paypal.com/2.0/"

client = PayPalAPIAAInterface.new(endpoint_url)
#End:ProOptionClientSetupChange
client.options['protocol.http.ssl_config.verify_mode'] = 
        OpenSSL::SSL::VERIFY_PEER
client.options['protocol.http.ssl_config.ca_file'] = 'api_cert_chain.crt'
client.options['protocol.http.ssl_config.client_cert'] = 'client.cert'
client.options['protocol.http.ssl_config.client_key'] = 'client.keys'
client.headerhandler << RequesterCredentialsHandler.new(api_user, api_pass,'')
# run ruby with -d to see SOAP wiredumps.
client.wiredump_dev = STDERR if $DEBUG



#Set up the request objects
req = DoDirectPaymentReq.new
requestType=DoDirectPaymentRequestType.new
req.doDirectPaymentRequest=requestType
#XML Version
requestType.version = "2.0"
requestDetails=DoDirectPaymentRequestDetailsType.new
requestType.doDirectPaymentRequestDetails=requestDetails
#PaymentAction = Sale
requestDetails.paymentAction=PaymentActionCodeType::Sale
requestDetails.iPAddress="127.0.0.3"
#PaymentDetails holds the order total
paymentDetails=PaymentDetailsType.new
requestDetails.paymentDetails=paymentDetails
total=BasicAmountType.new("100.03")
paymentDetails.orderTotal=total
total.xmlattr_currencyID='USD'
#Credit Card Details
ccDetails=CreditCardDetailsType.new
requestDetails.creditCard=ccDetails
ccDetails.creditCardType=CreditCardTypeType::Visa
ccDetails.creditCardNumber="4441450983322708"
ccDetails.expMonth=01
ccDetails.expYear=2016
ccDetails.cVV2="444"
#Need Payer Info
payer=PayerInfoType.new
ccDetails.cardOwner=payer
name=PersonNameType.new
payer.payerName=name
name.firstName="Bob"
name.lastName="Bodkin"
payer.payerCountry="US"
#Need billing address
billAddr=AddressType.new
payer.address=billAddr
billAddr.name="Bob Bodkin"
billAddr.street1="321 Lane"
billAddr.cityName="Paris"
billAddr.stateOrProvince="TX"
billAddr.postalCode="75401"
billAddr.country="US"



res = client.doDirectPayment(req)
puts "Ack = " + res.ack
PP.pp res.errors if res.ack != "Success"

