#---
# Excerpted from "Payment Processing with Paypal and Ruby",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/jfpaypal for more book information.
#---

#!/usr/bin/env ruby
require 'soap/header/simplehandler'
require 'defaultDriver'
require 'breakpoint'
require 'pp'


api_user="business_api1.bodkinconsulting.com"
api_pass="wsxwsxwsx"

# This class handles authentication for the soap4r client.

class RequesterCredentialsHandler < SOAP::Header::SimpleHandler
   HeaderName = XSD::QName.new('urn:ebay:api:PayPalAPI', 
       'RequesterCredentials')
   CredentialsName = XSD::QName.new('urn:ebay:apis:eBLBaseComponents', 
       'Credentials')
   UsernameName = XSD::QName.new(nil, 'Username')
   PasswordName = XSD::QName.new(nil, 'Password')
   SubjectName = XSD::QName.new(nil, 'Subject')

   def initialize(username, password, subject)
     super(HeaderName)
     @username, @password, @subject = username, password, subject
   end

   def on_simple_outbound
     {CredentialsName => {UsernameName => @username, PasswordName =>
@password,
       SubjectName => @subject}}
   end
 end 

 
# Either use the endpoint on the command line or the default

endpoint_url = "https://api-aa.sandbox.paypal.com/2.0/"

client = PayPalAPIAAInterface.new(endpoint_url)
#End:ExpressOptionClientSetupChange
client.options['protocol.http.ssl_config.verify_mode'] = 
    OpenSSL::SSL::VERIFY_PEER
client.options['protocol.http.ssl_config.ca_file'] = 'api_cert_chain.crt'
client.options['protocol.http.ssl_config.client_cert'] = 'client.cert'
client.options['protocol.http.ssl_config.client_key'] = 'client.keys'
client.headerhandler << RequesterCredentialsHandler.new(api_user, api_pass,'')
# run ruby with -d to see SOAP wiredumps.
client.wiredump_dev = STDERR if $DEBUG



#Set up the request objects
req = SetExpressCheckoutReq.new
requestType=SetExpressCheckoutRequestType.new
req.setExpressCheckoutRequest=requestType
#XML Version
#requestType.version = "2.0"
requestDetails=SetExpressCheckoutRequestDetailsType.new
requestType.setExpressCheckoutRequestDetails=requestDetails
#PaymentAction = Sale
requestDetails.paymentAction=PaymentActionCodeType::Sale
requestDetails.orderTotal=9.99
requestDetails.returnURL="http://www.google.com"
requestDetails.cancelURL="http://www.google.com"



res = client.doDirectPayment(req)
puts "Ack = " + res.ack
PP.pp res.errors if res.ack != "Success"

