#---
# Excerpted from "Payment Processing with Paypal and Ruby",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/jfpaypal for more book information.
#---
require 'PayPalHttpClient'
require 'PP'
require 'breakpoint'

class ExpressCheckoutController < ApplicationController

  def env_check
    result = "<hr>"
    $:.each {|x| result += (x + "<br>\n") }
    render_text(result)
  end

  def choose_express_payment
  end


  def start_express_payment
    @orderTotal = params[:orderTotal]
    session[:orderTotal] = @orderTotal
  end

  def getExpressToken orderTotal
    #Create request object
    expressRequestDetailsType=SetExpressCheckoutRequestDetailsType.new
    paymentDetailsType=BasicAmountType.new(orderTotal)
    paymentDetailsType.xmlattr_currencyID='USD'
    expressRequestDetailsType.orderTotal=paymentDetailsType
    session[:paymentDetailsType] = paymentDetailsType
    expressRequestDetailsType.returnURL="http://localhost:3000/express_checkout/success"
    expressRequestDetailsType.cancelURL="http://localhost:3000/express_checkout/cancel"
    expressRequestDetailsType.orderDescription="Test Order"
    expressRequestDetailsType.paymentAction="Sale"
    expressRequestType=SetExpressCheckoutRequestType.new 
    expressRequestType.version="2.0"
    expressRequestType.setExpressCheckoutRequestDetails=expressRequestDetailsType
    expressRequest=SetExpressCheckoutReq.new
    expressRequest.setExpressCheckoutRequest=expressRequestType
    paypalClient = PayPalHttpClient.new.aa_client_setup
    token = paypalClient.setExpressCheckout expressRequest 
    token.token
  end



  def redirect_outbound
    token = getExpressToken params[:orderTotal]
    redirect_to $PP_EXPRESS_CHECKOUT_REDIRECT_URL+token
  end


  def cancel
    render_text "CANCELED!"
  end


  def success
    @token = params[:token]
    session[:payerID] = params[:PayerID]
    session[:token] = params[:token]
    @payerInfo = getPayerInfo @token
  end

  def getPayerInfo token
    requestType = GetExpressCheckoutDetailsRequestType.new
    requestType.token = token
    requestType.version = "2.0"
    paypalClient = PayPalHttpClient.new.aa_client_setup
    request = GetExpressCheckoutDetailsReq.new
    request.getExpressCheckoutDetailsRequest=requestType
    resp = paypalClient.getExpressCheckoutDetails request
    details = resp.getExpressCheckoutDetailsResponseDetails
    return details.payerInfo
  end


  def thank_you
    confirm_order
  end


  def confirm_order
    requestTypeDetails = DoExpressCheckoutPaymentRequestDetailsType.new
    paymentDetails = PaymentDetailsType.new
    paymentDetails.orderTotal = session[:paymentDetailsType]
    requestTypeDetails.payerID = session[:payerID]
    requestTypeDetails.paymentAction = "Sale"
    requestTypeDetails.paymentDetails = paymentDetails
    requestTypeDetails.token = session[:token]
    requestType = DoExpressCheckoutPaymentRequestType.new
    requestType.version = "2.0"
    requestType.doExpressCheckoutPaymentRequestDetails=requestTypeDetails
    req = DoExpressCheckoutPaymentReq.new
    req.doExpressCheckoutPaymentRequest = requestType
    paypalClient = PayPalHttpClient.new.aa_client_setup
    resp = paypalClient.doExpressCheckoutPayment req
  end


end
