#---
# Excerpted from "Payment Processing with Paypal and Ruby",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/jfpaypal for more book information.
#---
class IpnsController < ApplicationController
  def index
    list
    render :action => 'list'
  end

  def list
    @ipn_pages, @ipns = paginate :ipns, :per_page => 10
  end

  def show
    @ipn = Ipn.find(params[:id])
  end

  def new
    @ipn = Ipn.new
  end

  def create
    @ipn = Ipn.new(params[:ipn])
    if @ipn.save
      flash[:notice] = 'Ipn was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @ipn = Ipn.find(params[:id])
  end

  def update
    @ipn = Ipn.find(params[:id])
    if @ipn.update_attributes(params[:ipn])
      flash[:notice] = 'Ipn was successfully updated.'
      redirect_to :action => 'show', :id => @ipn
    else
      render :action => 'edit'
    end
  end

  def destroy
    Ipn.find(params[:id]).destroy
    redirect_to :action => 'list'
  end


  def paypal_ipn
    @raw = request.raw_post
    logger.debug "Raw Post = #{@raw}"
    logger.debug "params = #{params}"
    @ipn = Ipn.new
    @ipn.payer_email = params[:payer_email]
    @ipn.payment_gross = params[:payment_gross]
    @ipn.payment_date = params[:payment_date]
    @ipn.raw_post = @raw
    @ipn.verified = ipnConfirm
    @ipn.save
  end



  def ipnConfirm
    uri = URI.parse("http://www.sandbox.paypal.com/cgi-bin/webscr")
    status = nil
    Net::HTTP.start(uri.host, uri.port) do |request|
        status = request.post(uri.path, @raw + "&cmd=_notify-validate").body
    end
    logger.debug "status = '#{status}'"
    status == "VERIFIED"
  end

end
