#---
# Excerpted from "Payment Processing with Paypal and Ruby",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/jfpaypal for more book information.
#---
class PdtsController < ApplicationController
  def index
    list
    render :action => 'list'
  end

  # GETs should be safe (see http://www.w3.org/2001/tag/doc/whenToUseGet.html)
  verify :method => :post, :only => [ :destroy, :create, :update ],
         :redirect_to => { :action => :list }

  def list
    @pdt_pages, @pdts = paginate :pdts, :per_page => 10
  end

  def show
    @pdt = Pdt.find(params[:id])
  end

  def new
    @pdt = Pdt.new
  end

  def create
    @pdt = Pdt.new(params[:pdt])
    if @pdt.save
      flash[:notice] = 'Pdt was successfully created.'
      redirect_to :action => 'list'
    else
      render :action => 'new'
    end
  end

  def edit
    @pdt = Pdt.find(params[:id])
  end

  def update
    @pdt = Pdt.find(params[:id])
    if @pdt.update_attributes(params[:pdt])
      flash[:notice] = 'Pdt was successfully updated.'
      redirect_to :action => 'show', :id => @pdt
    else
      render :action => 'edit'
    end
  end

  def destroy
    Pdt.find(params[:id]).destroy
    redirect_to :action => 'list'
  end


  def landing
    logger.debug request.raw_post 
    @pdt = Pdt.new
    @pdt.tx = params[:tx]
    @pdt.save
    @id_token="xLwKHicMsSaCFsP9Fap3Syw8m6ZZgbz5HRGY3iuq3G9mpp5ttDdPWqwqTmy"
    @tx_token=params[:tx]
    pdtConfirm
  end


  def pdtConfirm

    uri = URI.parse("http://www.sandbox.paypal.com/cgi-bin/webscr")
    postData="at=" + @id_token + "&tx=" + @tx_token + "&cmd=_notify-synch"
    logger.debug "postData=#{postData}"
    responseString = nil
    Net::HTTP.start(uri.host, uri.port) do |request|
        responseString = request.post(uri.path, postData).body
    end
    logger.debug "pdt responseString = '#{responseString}'"
    responseArray = responseString.split()
    logger.debug "pdt status = '#{responseArray[0]}'"

    @pdt.status=responseArray[0]
    @pdt.save
  end

  def getPdtDetails
    
  end
end
