#---
# Excerpted from "Payment Processing with Paypal and Ruby",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/jfpaypal for more book information.
#---

#!/usr/bin/env ruby
require 'soap/header/simplehandler'
require 'defaultDriver.rb'
require 'breakpoint'

class RequesterCredentialsHandler < SOAP::Header::SimpleHandler
   HeaderName = XSD::QName.new('urn:ebay:api:PayPalAPI',
'RequesterCredentials')
   CredentialsName =
     XSD::QName.new('urn:ebay:apis:eBLBaseComponents', 'Credentials')
   UsernameName = XSD::QName.new(nil, 'Username')
   PasswordName = XSD::QName.new(nil, 'Password')
   SubjectName = XSD::QName.new(nil, 'Subject')

   def initialize(username, password, subject)
     super(HeaderName)
     @username, @password, @subject = username, password, subject
   end

   def on_simple_outbound
     {CredentialsName => {UsernameName => @username, PasswordName =>
@password,
       SubjectName => @subject}}
   end
 end 
 
class PayPalHttpClient

    def client_setup
        client = PayPalAPIInterface.new($PP_ENDPOINT_URL)
        client.options['protocol.http.ssl_config.verify_mode'] = OpenSSL::SSL::VERIFY_PEER
        client.options['protocol.http.ssl_config.ca_file'] = $PP_CA_FILE
        client.options['protocol.http.ssl_config.client_cert'] = $PP_CLIENT_CERT
        client.options['protocol.http.ssl_config.client_key'] = $PP_CLIENT_KEY
        client.headerhandler << RequesterCredentialsHandler.new($PP_CLIENT_LOGIN, $PP_CLIENT_PASSWORD,'')
        client.wiredump_dev = $PP_DEBUG if $PP_DEBUG != nil
        return client
    end

    def aa_client_setup
        client = PayPalAPIAAInterface.new($PP_ENDPOINT_URL)
        client.options['protocol.http.ssl_config.verify_mode'] = OpenSSL::SSL::VERIFY_PEER
        client.options['protocol.http.ssl_config.ca_file'] = $PP_CA_FILE
        client.options['protocol.http.ssl_config.client_cert'] = $PP_CLIENT_CERT
        client.options['protocol.http.ssl_config.client_key'] = $PP_CLIENT_KEY
        client.headerhandler << RequesterCredentialsHandler.new($PP_CLIENT_LOGIN, $PP_CLIENT_PASSWORD,'')
        client.wiredump_dev = $PP_DEBUG if $PP_DEBUG != nil
        return client
    end
end



